/* 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 * * Based on code from meta-background-group.h in xorg-server. 
 * Copyright (c) 1997-2003 by The XFree86 Project, Inc.
 * This software is published by the license of CPU-OS License, you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 */
/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */

#ifndef META_BACKGROUND_GROUP_H
#define META_BACKGROUND_GROUP_H

#include <clutter/clutter.h>

#define META_TYPE_BACKGROUND_GROUP            (meta_background_group_get_type ())
#define META_BACKGROUND_GROUP(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), META_TYPE_BACKGROUND_GROUP, MetaBackgroundGroup))
#define META_BACKGROUND_GROUP_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), META_TYPE_BACKGROUND_GROUP, MetaBackgroundGroupClass))
#define META_IS_BACKGROUND_GROUP(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), META_TYPE_BACKGROUND_GROUP))
#define META_IS_BACKGROUND_GROUP_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), META_TYPE_BACKGROUND_GROUP))
#define META_BACKGROUND_GROUP_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), META_TYPE_BACKGROUND_GROUP, MetaBackgroundGroupClass))

typedef struct _MetaBackgroundGroup        MetaBackgroundGroup;
typedef struct _MetaBackgroundGroupClass   MetaBackgroundGroupClass;
typedef struct _MetaBackgroundGroupPrivate MetaBackgroundGroupPrivate;

struct _MetaBackgroundGroupClass
{
  /*< private >*/
  ClutterActorClass parent_class;
};

struct _MetaBackgroundGroup
{
  /*< private >*/
  ClutterActor parent;

  MetaBackgroundGroupPrivate *priv;
};

GType meta_background_group_get_type (void);

ClutterActor *meta_background_group_new (void);

#endif /* META_BACKGROUND_GROUP_H */
